
Robotics Service Bus - Support #1298
RSB and openCV: compile success depends on order of includes
12/13/2012 11:36 AM - C. Emmerich

Status: Rejected Start date: 12/13/2012
Priority: Normal Due date:
Assignee: % Done: 0%
Category: Estimated time: 0.00 hour
Target version:
Description

When including rsb-headers and openCV-headers in a project the succuess of compilation depends on the ordering of the includes.

The following works ...

#include <rsb/Factory.h>
#include <cv.h>

int main ( int argc, char **argv ) {
 // stuff
 return 0;
}

... whereas switching the include order to

#include <cv.h>
#include <rsb/Factory.h>

results in a compile error:

[ 57%] Building CXX object FlexIRobPerceptionChain/CMakeFiles/FlexIRobPerceptionChain.dir/main.cpp.o
In file included from /vol/flexirob/releases/trunk/include/rsb/Factory.h:41,                                                                                       
                         
                 from /homes/cemmeric/flexirob_workspace/Perception/FlexIRobPerceptionChain/main.cpp:23:
/vol/flexirob/releases/trunk/include/rsb/ParticipantConfig.h:217: error: expected identifier before ‘goto’
/vol/flexirob/releases/trunk/include/rsb/ParticipantConfig.h:217: error: expected ‘}’ before ‘goto’
/vol/flexirob/releases/trunk/include/rsb/ParticipantConfig.h:217: error: expected unqualified-id before ‘goto’
/vol/flexirob/releases/trunk/include/rsb/ParticipantConfig.h:224: error: expected unqualified-id before ‘)’ token
/vol/flexirob/releases/trunk/include/rsb/ParticipantConfig.h:225: error: declaration of ‘~rsb::ParticipantConfig’ as non-member
/vol/flexirob/releases/trunk/include/rsb/ParticipantConfig.h:232: error: non-member function ‘rsb::QualityOfServiceSpec
rsb::getQualityOfServiceSpec()’ cannot have cv-qualifier
/vol/flexirob/releases/trunk/include/rsb/ParticipantConfig.h:253: error: ‘ErrorStrategy’ does not name a type
...

Is this a bug in rsb? Or in openCV? Can that be fixed somehow?

Related issues:
Duplicates Robotics Service Bus - Bug # 1175: OpenCV preprocessor symbol coll... Resolved 09/28/2012

History
#1 - 12/13/2012 12:23 PM - J. Moringen

This is most likely a bug in OpenCV which probably contains code along the lines

#define EXIT goto bla bla

If project:rsb header are included after this definition, the token EXIT in the project:rsb code expands to goto bla bla, which does not make sense.

This could be fixed by renaming EXIT to something in project:rsb. But where should we stop? Upstream libraries could define a macro on any name.

#2 - 12/13/2012 12:25 PM - J. Wienke
- Status changed from New to Rejected

This is actually a duplicate of #1175.
